Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Rice Pastry API
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## rice.persistence
Class StorageManagerImpl

    java.lang.Object
      rice.persistence.StorageManagerImpl

All Implemented Interfaces:
  Cache, Catalog, Storage, StorageManager

public class StorageManagerImpl
extends java.lang.Object
implements StorageManager

This class provides both persistent and caching services to external applications. Building the StorageManager requires a Storage object, to provide the back-end storage, and a Cache to serve as a cache. Note that this implementation has seperate areas for the Cache and Storage, but the next version will allow the cache to use the unused storage space.

Version:
  $Id: pretty.settings 2305 2005-03-11 20:22:33Z jeffh $
Author:
  jeffh

Constructor Summary
`StorageManagerImpl(IdFactory factory, Storage storage, Cache cache)` Builds a StorageManager given a Storage object to provide storage services and a Cache object to provide caching services.

Method Summary
`void` | `cache(Id id, java.io.Serializable metadata, java.io.Serializable obj, Continuation c)` Caches an object in this storage.
`boolean` | `exists(Id id)` Returns whether or not an object is present in the location `id` .
`void` | `flush(Continuation c)` Method which is used to erase all data stored in the Catalog.
`Cache` | `getCache()` Returns the cache object used by this StorageManager
`long` | `getMaximumSize()` Returns the maximum size of the cache, in bytes.
`java.io.Serializable` | `getMetadata(Id id)` Returns the metadata associated with the provided object, or null if no metadata exists.
`void` | `getObject(Id id, Continuation c)` Returns the object identified by the given id, or `null` if there is no cooresponding object (through receiveResult on c).
`int` | `getSize()` Returns the number of Ids currently stored in the catalog
`Storage` | `getStorage()` Returns the permantent storage object used by this StorageManager
`long` | `getTotalSize()` Returns the total size of the stored data in bytes.The result is returned via the receiveResult method on the provided Continuation with an Integer representing the size.
`void` | `rename(Id oldId, Id newId, Continuation c)` Renames the given object to the new id.
`IdSet` | `scan()` Return all objects currently stored by this catalog NOTE: This method blocks so if the behavior of this method changes and no longer stored in memory, this method may be deprecated.
`IdSet` | `scan(IdRange range)` Return the objects identified by the given range of ids.
`java.util.SortedMap` | `scanMetadata()` Returns a map which contains keys mapping ids to the associated metadata.
`java.util.SortedMap` | `scanMetadata(IdRange range)` Returns a map which contains keys mapping ids to the associated metadata.
`java.util.SortedMap` | `scanMetadataValuesHead(java.lang.Object value)` Returns the submapping of ids which have metadata less than the provided value.
`java.util.SortedMap` | `scanMetadataValuesNull()` Returns the submapping of ids which have metadata null
`void` | `setMaximumSize(int size, Continuation c)` Sets the maximum size of the cache, in bytes.
`void` | `setMetadata(Id id, java.io.Serializable metadata, Continuation command)` Updates the metadata stored under the given key to be the provided value.
`void` | `store(Id id, java.io.Serializable metadata, java.io.Serializable obj, Continuation c)` Stores an object in this storage.
`void` | `uncache(Id id, Continuation c)` Removes the object from the list of cached objects.
`void` | `unstore(Id id, Continuation c)` Removes the object from the list of stored objects.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### StorageManagerImpl

    public StorageManagerImpl(IdFactory factory,
                              Storage storage,
                              Cache cache)

  Builds a StorageManager given a Storage object to provide storage services and a Cache object to provide caching services.

Parameters:
  `factory` - The factory to use for Id creation
  `storage` - The Storage object which will serve as the persistent storage.
  `cache` - The Cache object which will serve as the cache.

Method Detail

### getStorage

    public Storage getStorage()

  Returns the permantent storage object used by this StorageManager

  Specified by:
    `getStorage` in interface `StorageManager`
  Returns:
    The storage of this storage manager

### getCache

    public Cache getCache()

  Returns the cache object used by this StorageManager

  Specified by:
    `getCache` in interface `StorageManager`
  Returns:
    The cache of this storage manager

### getObject

    public void getObject(Id id,
                          Continuation c)

  Returns the object identified by the given id, or `null` if there is no cooresponding object (through receiveResult on c).

  Specified by:
    `getObject` in interface `Catalog`
  Parameters:
    `id` - The id of the object in question.
    `c` - The command to run once the operation is complete

### getMetadata

    public java.io.Serializable getMetadata(Id id)

  Returns the metadata associated with the provided object, or null if no metadata exists. The metadata must be stored in memory, so this operation is guaranteed to be fast and non-blocking.

  Specified by:
    `getMetadata` in interface `Catalog`
  Parameters:
    `id` - The id for which the metadata is needed
  Returns:
    The metadata, or null of non exists

### getTotalSize

    public long getTotalSize()

  Returns the total size of the stored data in bytes.The result is returned via the receiveResult method on the provided Continuation with an Integer representing the size.

  Specified by:
    `getTotalSize` in interface `Catalog`
  Returns:
    The TotalSize value

### getSize

    public int getSize()

  Returns the number of Ids currently stored in the catalog

  Specified by:
    `getSize` in interface `Catalog`
  Returns:
    The number of ids in the catalog

### getMaximumSize

    public long getMaximumSize()

  Returns the maximum size of the cache, in bytes. The result is returned via the receiveResult method on the provided Continuation with an Integer representing the size.

  Specified by:
    `getMaximumSize` in interface `Cache`
  Returns:
    The MaximumSize value

### setMetadata

    public void setMetadata(Id id,
                            java.io.Serializable metadata,
                            Continuation command)

  Updates the metadata stored under the given key to be the provided value. As this may require a disk access, the requestor must also provide a continuation to return the result to.

  Specified by:
    `setMetadata` in interface `Catalog`
  Parameters:
    `id` - The id for the metadata
    `metadata` - The metadata to store
    `command` - The new Metadata value

### setMaximumSize

    public void setMaximumSize(int size,
                               Continuation c)

  Sets the maximum size of the cache, in bytes. Setting this value to a smaller value than the current value may result in object being evicted from the cache. Returns the success or failure of the setSize operation (through receiveResult on c).

  Specified by:
    `setMaximumSize` in interface `Cache`
  Parameters:
    `size` - The new maximum size, in bytes, of the cache.
    `c` - The command to run once the operation is complete

### exists

    public boolean exists(Id id)

  Returns whether or not an object is present in the location `id` .

  Specified by:
    `exists` in interface `Catalog`
  Parameters:
    `id` - The id of the object in question.
  Returns:
    Whether or not an object is present at id.

### rename

    public void rename(Id oldId,
                       Id newId,
                       Continuation c)

  Renames the given object to the new id. This method is potentially faster than store/cache and unstore/uncache.

  Specified by:
    `rename` in interface `Catalog`
  Parameters:
    `oldId` - The id of the object in question.
    `newId` - The new id of the object in question.
    `c` - The command to run once the operation is complete

### scan

    public IdSet scan(IdRange range)

  Return the objects identified by the given range of ids. The IdSet returned contains the Ids of the stored objects. The range is partially inclusive, the lower range is inclusive, and the upper exclusive. NOTE: This method blocks so if the behavior of this method changes and no longer stored in memory, this method may be deprecated.

  Specified by:
    `scan` in interface `Catalog`
  Parameters:
    `range` - The range to query
  Returns:
    The idset containg the keys

### scan

    public IdSet scan()

  Return all objects currently stored by this catalog NOTE: This method blocks so if the behavior of this method changes and no longer stored in memory, this method may be deprecated.

  Specified by:
    `scan` in interface `Catalog`
  Returns:
    The idset containg the keys

### scanMetadata

    public java.util.SortedMap scanMetadata(IdRange range)

  Returns a map which contains keys mapping ids to the associated metadata.

  Specified by:
    `scanMetadata` in interface `Catalog`
  Parameters:
    `range` - The range to query
  Returns:
    The map containg the keys

### scanMetadata

    public java.util.SortedMap scanMetadata()

  Returns a map which contains keys mapping ids to the associated metadata.

  Specified by:
    `scanMetadata` in interface `Catalog`
  Returns:
    The treemap mapping ids to metadata

### scanMetadataValuesHead

    public java.util.SortedMap scanMetadataValuesHead(java.lang.Object value)

  Returns the submapping of ids which have metadata less than the provided value.

  Specified by:
    `scanMetadataValuesHead` in interface `Catalog`
  Parameters:
    `value` - The maximal metadata value
  Returns:
    The submapping

### scanMetadataValuesNull

    public java.util.SortedMap scanMetadataValuesNull()

  Returns the submapping of ids which have metadata null

  Specified by:
    `scanMetadataValuesNull` in interface `Catalog`
  Returns:
    The submapping

### store

    public void store(Id id,
                      java.io.Serializable metadata,
                      java.io.Serializable obj,
                      Continuation c)

  Stores an object in this storage. This method is non-blocking. If the object has already been stored at the location id, this method has the effect of calling `unstore(id)` followed by `store(id, obj)` . This method finishes by calling receiveResult() on the provided continuation with the success or failure of the store. Returns `True` if the action succeeds, else `False` (through receiveResult on c).

  Specified by:
    `store` in interface `Storage`
  Parameters:
    `id` - The object's id.
    `metadata` - The object's metadata
    `obj` - The object to store.
    `c` - The command to run once the operation is complete

### unstore

    public void unstore(Id id,
                        Continuation c)

  Removes the object from the list of stored objects. This method is non-blocking. If the object was not in the stored list in the first place, nothing happens and `False` is returned. Returns `True` if the action succeeds, else `False` (through receiveResult on c).

  Specified by:
    `unstore` in interface `Storage`
  Parameters:
    `c` - The command to run once the operation is complete
    `id` - DESCRIBE THE PARAMETER

### cache

    public void cache(Id id,
                      java.io.Serializable metadata,
                      java.io.Serializable obj,
                      Continuation c)

  Caches an object in this storage. This method is non-blocking. If the object has already been stored at the location id, this method has the effect of calling `uncachr(id)` followed by `cache(id, obj)` . This method finishes by calling receiveResult() on the provided continuation with whether or not the object was cached. Note that the object may not actually be cached due to the cache replacement policy. Returns `True` if the cache actaully stores the object, else `False` (through receiveResult on c).

  Specified by:
    `cache` in interface `Cache`
  Parameters:
    `id` - The object's id.
    `metadata` - The object's metadata
    `obj` - The object to cache.
    `c` - The command to run once the operation is complete

### uncache

    public void uncache(Id id,
                        Continuation c)

  Removes the object from the list of cached objects. This method is non-blocking. If the object was not in the cached list in the first place, nothing happens and `False` is returned. Returns `True` if the action succeeds, else `False` (through receiveResult on c).

  Specified by:
    `uncache` in interface `Cache`
  Parameters:
    `c` - The command to run once the operation is complete
    `id` - DESCRIBE THE PARAMETER

### flush

    public void flush(Continuation c)

  Method which is used to erase all data stored in the Catalog. Use this method with care!

  Specified by:
    `flush` in interface `Catalog`
  Parameters:
    `c` - The command to run once done

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Rice Pastry API
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2005 - Rice Pastry.